#include <iostream>
#define NO_ANT -1
#define MAX_ANTS_PER_CM 2

typedef struct {
	int[MAX_ANTS_PER_CM] ants;
} rodcm;

typedef struct {
	int pos;
	int dir;
	bool processed;
	int posOnCm;
} ant;

void swap(ant &a, ant &b) {
	ant tmp = a;
	a = b;
	b = tmp;
}

void swap(int &a, int &b) {
	int tmp = a;
	a = b;
	b = tmp;
}

bool noant(rodcm cm) {
	for (int i = 0; i < MAX_ANTS_PER_CM; i++) {
		if (cm.ants[i] != NO_ANT) return false;
	}
	return true;
}

int main() {
	int length;
	int antCount;
	while (std::cin >> length && std::cin >> ants) {
		rodcm rod[length];
		ant ants[antCount];
		for (int i = 0; i < length; i++) { // INIT ROD
			for (int j = 0; j < MAX_ANTS_PER_CM; j++) {			
				rod[i].ants[j] = NO_ANT;
			}
		}

		for (int i = 0; i < antCount; i++) { // INIT ANTS
			std::cin >> ants[i].pos;
			char dir;
			std::cin >> dir;
			ants[i].dir = dir == 'L' ? -1 : 1;
			rod[ants[i].pos].ants[0] = i;
			ants[i].posOnCm = 0;
		}

		unsigned long long seconds = 0;
		while (antCount > 0) {
			seconds++;
			for (int i = 0; i < antCount; i++) ants[i].processed = false;
			for (int i = 0; i < antCount; i++) {
				if (ants[i].processed) continue;
				int newPos = antPositions[i] + antDirections[i];
				if (newPos == length || newPos < 0) { // KILL ANT
					rod[ants[i].pos].ants[0] = NO_ANT;
					antCount--;
					swap(ants[i], ants[antCount]);

					rod[ants[i].pos].ants[0] = i;
	
					if (ants[i].processed) continue;
				}

				int newAntPos = ants[i].pos + ants[i].dir;
				if (noant(rod[newAntPos])) { // FREE TO GO
					rod[ants[i].pos].ants[ants[i].posOnCm] = NO_ANT; // leave rod cm
					ants[i].pos += ants[i].dir; // remember new pos
					rod[ants[i].pos].ants[0] = i; // new place on rod
					ants[i].posOnCm = 0; // it was free
					continue;
				}

				

				if (ants[rod[newAntPos].ants[0]].processed) { // CONFLICT, BOTH ON SAME CM NOW
					rod[ants[i].pos].ants[ants[i].posOnCm] = NO_ANT; // leave
					ants[i].pos += ants[i].dir; // remember new pos
					rod[ants[i].pos].ants[1] = i; // new place on rod
					ants[i].posOnCm = 1; // we share now
					for (int j = 0; j < MAX_ANTS_PER_CM; j++) {
						ants[rod[ants[i].pos].ants[j]].dir *= -1; // Turn them both around
					}
					continue;
				}

				int antOnCmWithConflict = NO_ANT;
				for (int j = 0; j < MAX_ANTS_PER_CM; j++) {
					int newPosAntIndex = rod[newAntPos].ants[j];
					if (newPosAntIndex != NO_ANT) {
						if (ants[newPosAntIndex].dir == ants[i].dir * -1) {
							antOnCmWithConflict = j;
						}
					}
				}

				swap(rod[ants[i.pos]].ants[ants[i].posOnCm], rod[newAntPos].ants[antOnCmWithConflict
				rod[ants[i].pos].ants[1] = i; // new place on rod
				ants[i].posOnCm = 1; // we share now
				for (int j = 0; j < MAX_ANTS_PER_CM; j++) {
					ants[rod[ants[i].pos].ants[j]].dir *= -1; // Turn them both around
				}

				ants[i].processed = true;
			}
		}
		std::cout << "The last ant will fall down in " << seconds << " seconds.\n";
	}
}
