#include <iostream>
using namespace std;

const char *SPODOK = "_|_";
const char * STRED = "/|\\";
const char * VRCH = ".^.";

void drawSeq(char *buff, int buffSize,const char *seq, int x, int y) {
	if (y >= buffSize - 1 || y <= 0) return;
	int start = (y+1) * buffSize + x;
	for (int i = -1; i < 2; i++) {
		if (x + i < buffSize - 1 && x + i > 0) {
			buff[start + i] = seq[i];
		}
	}
}

const char * getSeq(int i, int height) {
	if (i == 0) return SPODOK;
	if (i == height - 1) return VRCH;
	return  STRED;
}

void draw(char *buff, int size, int height, int x, int y) {
	if (height == 0) {
		drawSeq(buff, size, "_o_", x, y);
	} else {
		for (int i = 0; i < height; i++)
			drawSeq(buff, size, getSeq(i, height), x, y + i);
	}
}

int main() {
	ios::sync_with_stdio(false);
	int size;
	int objectc;
	while (cin >> size && cin >> objectc) {
		size+=2;
		char art[size*size];
		for (int i = 0; i < size; i++) {
			art[i] = '*';
			art[(size - 1) * size + i] = '*';
			art[i * size] = '*';
			art[i * size + (size - 1)] = '*';
		}
		
		for (int i = 1; i < size - 1; i++) {
			for (int j = 1; j < size - 1; j++) {
				art[j * size + i] = '.';
			}
		}
		
		for (int i = 0; i < objectc; i++) {
			int height;
			int x;
			int y;
			cin >> height, cin >> x, cin >> y;
			draw(art, size, height, x, y);
		}
		
		for (int i = 0; i < (size); i++) {
			for (int j = 0; j < (size); j++) {
				cout << art[j * size + i];
			}
			cout << '\n';
		}
		
	}

	return 0;
}
