#include <iostream>
#include <vector>
#include <set>
#define BLACK true
#define RED false
using namespace std;
typedef struct {
long long int x;
long long int y;
bool hasColor;
bool color;
} point;

int countPoints(vector<point> &points, vector<point *> &grid, point &entry, int width, int height);
int main() {
//	ios::sync_with_stdio(false);
	int numPoints;
	while (cin >> numPoints) {
		vector<point> points(numPoints);
		int minWidth = 0;
		int minHeight = 0;
		for (int i =0; i < numPoints; i++) {
			cin >> points[i].x; cin >> points[i].y;
			points[i].hasColor = false;
			if (points[i].x + 1 > minWidth) minWidth = points[i].x + 1;
			if (points[i].y + 1> minHeight) minHeight = points[i].y + 1;
		}
		vector<point *> grid(minWidth * minHeight);
		for (point &p : points) {
			grid[p.y * minWidth + p.x] = &p;
		}
		
		int count = 0;
		for (point &p : points) {
			if (!p.hasColor) {
				count += countPoints(points, grid, p, minWidth, minHeight);
			}
		}
		cout << count << '\n';
	}

	return 0;
}

int countPoints(vector<point> &points, vector<point *> &grid, point &entry, int width, int height) {
	cout << "entering at " << entry.x << " "<< entry.y << endl;
	set<point *> tbprc;
	int blackCount = 1;
	int redCount = 0;
	tbprc.insert(&entry);
	entry.color = BLACK;
	entry.hasColor = true;
	while (!tbprc.empty()) {
		set<point *> tbprc2;
		for (point *p : tbprc) {
			
			for (int xOff = -1; xOff <= 1; xOff++) {
				for (int yOff = -1; yOff <= 1; yOff++) {
					if ((xOff != 0 && yOff != 0) || (xOff == 0 && yOff == 0)) continue;
					int newX = xOff + p->x;
					int newY = yOff + p->y;
					if (p->x + xOff >= 0 &&
						p->y + yOff >= 0 &&
						p->x + xOff < width &&
						p->y + yOff < height &&
						grid[newY * width + newX] &&
						!grid[newY * width + newX]->hasColor) {
						
						cout << "discovered " << (p->x + xOff)<< " " << (p->y + yOff) << endl;
						tbprc2.insert(grid[newY * width + newX]);
						grid[newY * width + newX]->color = !p->color;
						grid[newY * width + newX]->hasColor = true;
						if (p->color == BLACK) {
							redCount++;
						} else {
							blackCount++;
						}
					}		
				}	
			}
		}
		tbprc = tbprc2;
	}
	return blackCount > redCount ? blackCount : redCount;
}
